package Echiquier.Piece;

import Echiquier.Case;
import Echiquier.ColorJoueur;
import Echiquier.EchiquierException;

public class Cavalier extends Piece {
    public Cavalier(Case unCase, ColorJoueur colorJoueur) {
        super(unCase, colorJoueur);
    }

    public boolean estDpValide(Case arrive){
        //Si le case arrive a un piece de le meme joueur retourn false
        if(null != arrive.getPiece()) {
            if (getColorJoueur() == arrive.getPiece().getColorJoueur()) {
                return false;
            }
        }

        int ligDepart = this.unCase.getLig();
        int colDepart = this.unCase.getCol();

        int ligArrive = arrive.getLig();
        int colArrive = arrive.getCol();

        //Si le movement n'est pas un 'L' return false
        if( !(Math.abs(ligArrive - ligDepart) == 2 && Math.abs(colArrive - colDepart) == 1 ||
                Math.abs(ligArrive - ligDepart) == 1 && Math.abs(colArrive - colDepart) == 2)){
            return false;
        }

        return true;
    }
}
